#!/usr/bin/perl
# Database rotation script

# The main database
$db = "/big/dom/xusemod/db/wikibase.db";

# Backup directory files
$bk = "/big/dom/xusemod/db/wikibase_";

# Lock directory (must *not* exist)
$LockDirectory = "/big/dom/xusemod/db/wikibase/lockdir";

# Acquire the lock or abort
$n = 0;
while (mkdir($LockDirectory, 0555) == 0) {
  # EEXIST == 17 is OK, try later.
  $! == 17 || die("can't make $LockDirectory: $!\n");
  $n++ < 15 || die("timed out waiting for $LockDirectory\n");
  sleep(2);
}

# Remove the oldest backup
system("rm ${bk}4.db");

# Move the existing backups
system("mv ${bk}3.db ${bk}4.db");
system("mv ${bk}2.db ${bk}3.db");
system("mv ${bk}1.db ${bk}2.db");

# Copy the live db
system("cp $db ${bk}1.db");

# Remove the lock
rmdir($LockDirectory);

